
#include <Servo.h>

//initializari servomotor
Servo servo;
int initialangle = 0; //pozitia initiala 
int nr_incercari = 3; //nr incercari de introdus pin pentru deschidere usa


//initializari senzor PIR
int pirPin = 2;
int pirStat = 0;
int ledPin = 12;

//initializari senzor Capacitiv TTP223
int touch = 3; //pinul 3 pentru Senzor Capacitiv TTP223
int nr_bruscari = 3;

//initializari buzzer
int buzzPin = 5;
int buzz = HIGH;

void setup () //se executa o singura data la inceput
{

  //pornim comunicarea serială cu baud rate de 9600
  Serial.begin(9600);

  //pentru servo
  servo.attach(8); //pinul prin care vom da comanda servomotorului
  servo.write(initialangle); //seteaza pozitia initiala servo
  Serial.println("Introduceti parola:");

  //pentru  snezorul PIR
  pinMode(ledPin, OUTPUT);
  pinMode(pirPin, INPUT);

  //pentru senzor Capacitiv TTP223
  pinMode(touch, INPUT);

  //pentru buzzer
  pinMode(buzzPin, OUTPUT);

  delay(1000);
}

void loop() //se executa in loop
{
  
//senzor PIR 
  pirStat = digitalRead(pirPin); //citeste starea senzorului PIR

  if (pirStat == HIGH) {            // daca s a detectat miscare
    digitalWrite(ledPin, HIGH);     // aprind bec
    delay(3000); //sta aprins 3 sec
  }
  else {

    digitalWrite(ledPin, LOW); //se stinge becul cand nu mai e miscare
  }

//deschiderea usii prin PAROLA (Servo)
  String pin = ""; //initializare variabila pentru parola
  if ( Serial.available() > 0) // daca avem comunicarea seriala libera
  {
    pin = Serial.readString(); //Read the data from  the serial port;
    if (pin == "1234")
    {
      Serial.println("Parola corecta: USA DESCHISA (se inchide peste 5 sec)");

      for (int angle = servo.read(); angle <= 90; angle++) //servo.read() - citeste pozitia curenta servo
      {
        servo.write(angle);
        delay(15);
      }

      delay(5000); //asteapta 5 sec, apoi se inchide usa

      Serial.println(" USA SE INCHIDE! ");
      for (int angle = servo.read(); angle >= 0; angle--)
      {
        servo.write(angle);
        delay(15);
      }
    }
    else //daca s-a introdus gresit parola
    {
      if (nr_incercari > 0)
      {
        nr_incercari = nr_incercari - 1;
        
        Serial.print("Parola gresita!!!!! Mai aveti ");
        Serial.print(nr_incercari);
        Serial.println(" incercari");
      }
      else {
        Serial.println("PERICOL!!!!");
      }
    }
  }
  
//SENZOR Capacitiv TTP223
  boolean stare_touch;
  stare_touch = digitalRead(touch); //citeste starea senzorului TTP

  if (stare_touch == HIGH) //daca a fost atins
  {
    nr_bruscari = nr_bruscari - 1; //numar de cate ori s-a bruscat usa
    Serial.print("S-a incercat deshiderea usii prin fortare de ");
    Serial.print(3 - nr_bruscari);
    Serial.println(" ori. ");
    
    //limitare nr bruscari
    if (nr_bruscari <= 0)
    {
      nr_bruscari = 0;
    }
  }

//buzzer
  while (nr_bruscari == 1 or nr_incercari == 1)
  {
    Serial.println("ATENTIE!!! PERICOL DE SPARGERE!!!");
    for (int i = 0; i < 80; i++)
    {
      digitalWrite(buzzPin, LOW);
      delay(1);
      digitalWrite(buzzPin, HIGH);
      delay(1);
    }

   
    //reinitializam
    nr_bruscari = 3;
    nr_incercari = 3;
  }
}